//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3768133EF956.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3768133EF956.cm

//## begin module%3768133EF956.cp preserve=no
//## end module%3768133EF956.cp

//## Module: Component%3768133EF956; Package specification
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/Component.h

#ifndef COMPONENT_H
#define COMPONENT_H 1

//## begin module%3768133EF956.additionalIncludes preserve=no
//## end module%3768133EF956.additionalIncludes

//## begin module%3768133EF956.includes preserve=yes
//#include "UserInterface/TclStream.h"
//## end module%3768133EF956.includes

// utility
#include <utility>
// iosfwd
#include <iosfwd>
// Error
#include <XSUtil/Error/Error.h>
// XSutility
#include <XSUtil/Utils/XSutility.h>
// ComponentInfo
#include <XSUtil/FunctionUtils/ComponentInfo.h>
// Parameter
#include <XSModel/Parameter/Parameter.h>

class UniqueEnergy;
class SumComponent;
class ComponentBase;
class CGroupBase;

//## begin module%3768133EF956.declarations preserve=no
//## end module%3768133EF956.declarations

//## begin module%3768133EF956.additionalDeclarations preserve=yes
#include <set>

template <typename T>
class XSCall;
class MathExpression;
class ModParam;
class ModelBase;
//## end module%3768133EF956.additionalDeclarations


//## begin Component%362807A60028.preface preserve=yes
//## end Component%362807A60028.preface

//## Class: Component%362807A60028; Abstract
//## Category: XSModel::Model::Component%3666B89A8340
//## Subsystem: XSModel::Model::Component%367691A33718
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3A7F20C403A4;std::ostringstream { -> }
//## Uses: <unnamed>%3A8AD07C0361;Parameter { -> }
//## Uses: <unnamed>%3AD736E10020;SumComponent { -> F}
//## Uses: <unnamed>%3C18C7A20376;CGroupBase { -> F}
//## Uses: <unnamed>%43D78B190145;UniqueEnergy { -> F}

class Component 
{
  //## begin Component%362807A60028.initialDeclarations preserve=yes
  //## end Component%362807A60028.initialDeclarations

  public:
    //## Class: BadTableFileName%37653E04FCE8
    //## Category: XSModel::Model::Component%3666B89A8340
    //## Subsystem: XSModel::Model::Component%367691A33718
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    //## Uses: <unnamed>%3804B648ECF8; { -> }

    class BadTableFileName : public YellowAlert  //## Inherits: <unnamed>%37653EB187D0
    {
      public:
        //## Constructors (specified)
          //## Operation: BadTableFileName%37653FA80888;    C++
          //	Class Component::BadTableFileName
          BadTableFileName (const string& errName = "(no input file specified)");

      protected:
      private:
      private: //## implementation
    };

    //## Class: SpectrumNotDefined%3DF6140B0298
    //## Category: XSModel::Model::Component%3666B89A8340
    //## Subsystem: XSModel::Model::Component%367691A33718
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class SpectrumNotDefined : public YellowAlert  //## Inherits: <unnamed>%3DF6140B029B
    {
      public:
        //## Constructors (specified)
          //## Operation: SpectrumNotDefined%3DF6140B029C
          SpectrumNotDefined (const string& diag);

      protected:
      private:
      private: //## implementation
    };

    //## Class: NoSuchComponent%3F1D70930272
    //## Category: XSModel::Model::Component%3666B89A8340
    //## Subsystem: XSModel::Model::Component%367691A33718
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class NoSuchComponent : public YellowAlert  //## Inherits: <unnamed>%3F1D717402B6
    {
      public:
        //## Constructors (specified)
          //## Operation: NoSuchComponent%3F1D70FD0058
          NoSuchComponent (const string& msg);

      protected:
      private:
      private: //## implementation
    };

    //## Destructor (generated)
      virtual ~Component();

    //## Assignment Operation (generated)
      Component & operator=(const Component &right);


    //## Other Operations (specified)
      //## Operation: read%374D98C8F3F0; C++
      //	Read function for all model components that are
      //	generated from the model.dat file. read is overloaded
      //	for all other types.
      virtual int read ();

      //## Operation: getSetupData%374D98C8FF3C;          C++
      //	Reads datafile (model.dat) to decide which component clas
      //	s to instantiate and where in the file to find that data.
      //	 Alternatively, grabs equivalent information from table f
      //	its
      //	file.
      static void getSetupData (const string& modelName);

      //## Operation: addParam%374D98C8FF40;       C++
      //	Function to add a parameter (e.g. normalization,
      //	redshift) to the parameterSet member.
      //	      //	With no arguments, addpar will add a normalizati
      //	on
      //	With no arguments, addpar will add a normalization
      //	parameter with the default limits.
      void addParam (const string& paramName = "norm", const string& unit = "", Real value = 1., Real top = 1.e+24, Real max = 1.e+24, Real bot = 0., Real min = 0., Real delta = 0.01);

      //## Operation: clone%377101078A20;    C++
      virtual Component* clone (CGroupBase* p) const = 0;

      //## Operation: calculate%374D98C8F3EE;            C++
      virtual void calculate (bool saveComponentFlux, bool frozen) = 0;

      //## Operation: setParamValues%38EE1428E338
      //	Method called to set values of parameters from input
      //	strings paramStrings.
      //
      //	The default argument parameterNumbers, if not set, means
      //	'set all numbers'. If the argument is supplied it allows
      //	setting parameters by index number.
      //
      //	If parameterNumbers is non-empty, its size and  the size
      //	of  the paramStrings vector must be the same.
      void setParamValues (const std::vector<string>& paramString, const IntegerArray& parameterNumbers = IntegerArray());

      //## Operation: getParamValues%392D7CA80171
      void getParamValues (const string& modString, std::vector<string>& componentParams) const;

      //## Operation: isNested%3D04C9A1002A
      virtual bool isNested () const;

      //## Operation: name%3A8ADA240007
      const string& name () const;

      //## Operation: index%3A8B07BA016A
      int index () const;

      //## Operation: parameterSet%3A8B0D220328
      const std::vector<Parameter*>& parameterSet () const;

      //## Operation: name%3A8BFF40033B
      void name (const string& id);

      //## Operation: index%3A8C02F3026C
      void index (int i);

      //## Operation: parentName%3A9E7EED0207
      const string& parentName () const;

      //## Operation: dataGroup%3A9E91FD008D
      size_t dataGroup () const;

      //## Operation: registerParameters%3A9EA5A800B2
      virtual void registerParameters () const;

      //## Operation: reindexParameters%3AA404B1022A
      void reindexParameters (int parameterOffset);

      //## Operation: modelIndex%3AA6966D00D0
      size_t modelIndex () const;

      //## Operation: localParameter%3AA93F1E0187
      Parameter* localParameter (size_t i) const;

      //## Operation: linkParametersToPrimary%3AB22FAD0173
      void linkParametersToPrimary ();

      //## Operation: getEnergyArray%3AD31E2B0338
      const ArrayContainer& getEnergyArray () const;

      //## Operation: isError%3AD3462D001A
      bool isError () const;

      //## Operation: operator*%3AD734DB038A
      virtual SumComponent& operator * (SumComponent& right) const;

      //## Operation: isError%3AD743870383
      void isError (bool val) const;

      //## Operation: currentType%3AE496980118
      static const string& currentType ();

      //## Operation: currentModelName%3AE496FA0180
      static const string& currentModelName ();

      //## Operation: currentType%3AE499EE008F
      static void currentType (const string& value);

      //## Operation: currentModelName%3AE49A1B00BA
      static void currentModelName (const string& value);

      //## Operation: numParams%3B978FAE0027
      size_t numParams () const;

      //## Operation: setParent%3C0D0B9C0375
      void setParent (CGroupBase* p);

      //## Operation: error%3C0D0D6901E0
      void error (bool value);

      //## Operation: debugPrint%3C1E61240332
      void debugPrint (std::ostream& s, const string& descript) const;

      //## Operation: recompute%3C20E0F80205
      bool recompute () const;

      //## Operation: recompute%3C20E140037A
      void recompute (bool value);

      //## Operation: parameter%3C6D3CE7032A
      Parameter* parameter (const string& paramName) const;

      //## Operation: energyArray%3C7531AD005F
      const RealArray& energyArray (size_t spectrumNumber) const;

      //## Operation: clearArrays%3C7670D3037A
      virtual void clearArrays (const std::set<UniqueEnergy*>& currentUniqueEngs);

      //## Operation: getVariableParameters%3C7BA85B03B3
      std::vector<ModParam*> getVariableParameters () const;

      //## Operation: isGroup%3D074F230113
      bool isGroup () const;

      //## Operation: combine%3D08F74200DC
      void combine ();

      //## Operation: setParameterSet%3DD1315C0293
      void setParameterSet (std::vector<Parameter*>& parameters);

      //## Operation: sources%3DE7B78501EE
      std::list<SumComponent*> sources ();

      //## Operation: nameCache%3EF09BBD0221
      static const NameCacheType& nameCache ();

      //## Operation: parameterIndices%3EFB02BE0234
      IntegerArray parameterIndices () const;

      //## Operation: resequenceParameters%3EFB475703AC
      int resequenceParameters (int startValue);

      //## Operation: deregisterParameters%3F297F57023A
      virtual void deregisterParameters () const;

      //## Operation: getUniqueEnergies%43D6523000C4
      const std::set<UniqueEnergy*>& getUniqueEnergies () const;

      //## Operation: uniquePhotonArray%43D789B2028C
      const RealArray& uniquePhotonArray (const UniqueEnergy* uniqueEnergy) const;

      //## Operation: uniquePhotonArray%43D78BD70160
      const UniquePhotonContainer& uniquePhotonArray () const;

      //## Operation: setUniquePhotonArray%43D78CA10174
      void setUniquePhotonArray (const UniquePhotonContainer& value);

      //## Operation: saveUniquePhotonArray%43D78D850311
      virtual void saveUniquePhotonArray (bool setSaveFlag = true);

      //## Operation: restoreUniquePhotonArray%43D78DA50285
      virtual void restoreUniquePhotonArray ();

      //## Operation: uniquePhotonErrArray%43D790940321
      const RealArray& uniquePhotonErrArray (const UniqueEnergy* uniqueEnergy) const;

      //## Operation: uniquePhotonErrArray%43D7912C01B5
      const UniquePhotonContainer& uniquePhotonErrArray () const;

      //## Operation: setUniquePhotonErrArray%43D791FB01F2
      void setUniquePhotonErrArray (const UniquePhotonContainer& value);

      //## Operation: isSpectrumDependency%43E8E51902E1
      bool isSpectrumDependency () const;

      //## Operation: initializeForFit%4593FE150149
      virtual void initializeForFit ();

      //## Operation: usingMdef%481F2ABB02CB
      bool usingMdef (const XSCall<MathExpression>* mdef) const;

      //## Operation: toSumComponent%48FF7B4C00A2
      //	Alternative to dynamic_cast when checking for Sum
      //	Components.
      virtual SumComponent* toSumComponent ();

  public:
    // Additional Public Declarations
      //## begin Component%362807A60028.public preserve=yes
      friend std::ostream& operator<<(std::ostream& stream, const Component& output);
      //## end Component%362807A60028.public
  protected:
    //## Constructors (generated)
      Component(const Component &right);

    //## Constructors (specified)
      //## Operation: Component%37EF8DD8C950;    C++
      Component (CGroupBase* p);


    //## Other Operations (specified)
      //## Operation: parameterSet%392D8C6E03A5
      //	Access by index number. Convenient for some
      //	applications.
      const Parameter* parameterSet (size_t index) const;

      //## Operation: swap%3A8AD60801C5
      virtual void swap (Component& right);

      //## Operation: parameterSet%3A8AFE3E0117
      std::vector<Parameter*>& parameterSet ();

      //## Operation: parameterSet%3A8B0D8A0170
      //	Access by index number. Convenient for some
      //	applications.
      Parameter* parameterSet (size_t index);

      //## Operation: componentBase%3AD1D8B3007E
      const ComponentBase* componentBase () const;

      //## Operation: parent%3C0D1823019C
      const CGroupBase* parent () const;

      //## Operation: componentBase%3D64071600C9
      ComponentBase* componentBase ();

      //## Operation: cloneParameters%3DD12E690170
      void cloneParameters (Component& left, const Component& right);

      //## Operation: root%3F902C020280
      const ModelBase* root () const;

      //## Operation: uniquePhotonArray%43D78E6D00FB
      RealArray& uniquePhotonArray (const UniqueEnergy* uniqueEnergy);

      //## Operation: uniquePhotonArray%43D78F7F02B8
      void uniquePhotonArray (const UniqueEnergy* uniqueEnergy, const RealArray& value);

      //## Operation: uniquePhotonErrArray%43D793200307
      RealArray& uniquePhotonErrArray (const UniqueEnergy* uniqueEnergy);

      //## Operation: uniquePhotonErrArray%43D793950357
      void uniquePhotonErrArray (const UniqueEnergy* uniqueEnergy, const RealArray& value);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: currentIsTable%374D98C8DFC8
      //	Table model flag. Table models are a subclass of their
      //	corresponding model type. This static flag is used to
      //	set up the ComponentCreator to instantiate a table model
      //	instance
      static const bool currentIsTable ();
      static void currentIsTable (bool value);

    // Additional Protected Declarations
      //## begin Component%362807A60028.protected preserve=yes
      //## end Component%362807A60028.protected

  private:

    //## Other Operations (specified)
      //## Operation: copy%3A9539F40093
      virtual void copy (const Component& right) = 0;

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Model::Component::Component Pointer%3C0D03B401E0
      //## Role: Component::componentBase%3C0D03B403C3
      void componentBase (ComponentBase* value);

      //## Association: XSModel::Model::Component::<unnamed>%3C18CA530072
      //## Role: Component::currentModelInfo%3C18CA53031A
      static const ComponentInfo& currentModelInfo ();
      static void currentModelInfo (const ComponentInfo& value);

    // Additional Private Declarations
      //## begin Component%362807A60028.private preserve=yes
      //## end Component%362807A60028.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin Component::currentIsTable%374D98C8DFC8.attr preserve=no  protected: static bool {U} false
      static bool s_currentIsTable;
      //## end Component::currentIsTable%374D98C8DFC8.attr

    // Data Members for Associations

      //## Association: XSModel::Model::Component::Component Pointer%3C0D03B401E0
      //## begin Component::componentBase%3C0D03B403C3.role preserve=no  private: ComponentBase { -> 1RFHgN}
      ComponentBase* m_componentBase;
      //## end Component::componentBase%3C0D03B403C3.role

      //## Association: XSModel::Model::Component::<unnamed>%3C18CA530072
      //## begin Component::currentModelInfo%3C18CA53031A.role preserve=no  private: static ComponentInfo { -> 1VHgN}
      static ComponentInfo s_currentModelInfo;
      //## end Component::currentModelInfo%3C18CA53031A.role

    // Additional Implementation Declarations
      //## begin Component%362807A60028.implementation preserve=yes
      //## end Component%362807A60028.implementation

  //## begin Component%362807A60028.friends preserve=yes
    friend class ComponentCreator;
    friend void Parameter::reset() throw (Parameter::ResetFailure);
  //## end Component%362807A60028.friends
};

//## begin Component%362807A60028.postscript preserve=yes
//## end Component%362807A60028.postscript

// Class Component::BadTableFileName 

// Class Component::SpectrumNotDefined 

// Class Component::NoSuchComponent 

// Class Component 


//## Other Operations (inline)
inline const ComponentBase* Component::componentBase () const
{
  //## begin Component::componentBase%3AD1D8B3007E.body preserve=yes
  //## end Component::componentBase%3AD1D8B3007E.body

  return m_componentBase;
}

inline ComponentBase* Component::componentBase ()
{
  //## begin Component::componentBase%3D64071600C9.body preserve=yes
  //## end Component::componentBase%3D64071600C9.body

  return m_componentBase;
}

inline SumComponent* Component::toSumComponent ()
{
  //## begin Component::toSumComponent%48FF7B4C00A2.body preserve=yes
   return 0;
  //## end Component::toSumComponent%48FF7B4C00A2.body
}

//## Get and Set Operations for Class Attributes (inline)

inline const bool Component::currentIsTable ()
{
  //## begin Component::currentIsTable%374D98C8DFC8.get preserve=no
  return s_currentIsTable;
  //## end Component::currentIsTable%374D98C8DFC8.get
}

inline void Component::currentIsTable (bool value)
{
  //## begin Component::currentIsTable%374D98C8DFC8.set preserve=no
  s_currentIsTable = value;
  //## end Component::currentIsTable%374D98C8DFC8.set
}

//## Get and Set Operations for Associations (inline)

inline void Component::componentBase (ComponentBase* value)
{
  //## begin Component::componentBase%3C0D03B403C3.set preserve=no
  m_componentBase = value;
  //## end Component::componentBase%3C0D03B403C3.set
}

inline const ComponentInfo& Component::currentModelInfo ()
{
  //## begin Component::currentModelInfo%3C18CA53031A.get preserve=no
  return s_currentModelInfo;
  //## end Component::currentModelInfo%3C18CA53031A.get
}

inline void Component::currentModelInfo (const ComponentInfo& value)
{
  //## begin Component::currentModelInfo%3C18CA53031A.set preserve=no
  s_currentModelInfo = value;
  //## end Component::currentModelInfo%3C18CA53031A.set
}

//## begin module%3768133EF956.epilog preserve=yes
//## end module%3768133EF956.epilog


#endif
